diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_mem.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_mem.c
--- src/netsys/netsys_c_mem.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_mem.c	2026-05-29 06:31:44
@@ -30,8 +30,8 @@
 					    value soffv,
 					    value lenv)
 {
-    struct caml_bigarray *mem = Bigarray_val(memv);
-    char * s = Bytes_val(sv);
+    struct caml_ba_array *mem = Caml_ba_array_val(memv);
+    unsigned char * s = Bytes_val(sv);
     long memoff = Long_val(memoffv);
     long soff = Long_val(soffv);
     long len = Long_val(lenv);
@@ -48,7 +48,7 @@
 					    value memoffv,
 					    value lenv)
 {
-    struct caml_bigarray *mem = Bigarray_val(memv);
+    struct caml_ba_array *mem = Caml_ba_array_val(memv);
     const char * s = String_val(sv);
     long memoff = Long_val(memoffv);
     long soff = Long_val(soffv);
@@ -62,7 +62,7 @@
 
 CAMLprim value netsys_memory_address(value memv)
 {
-    struct caml_bigarray *mem = Bigarray_val(memv);
+    struct caml_ba_array *mem = Caml_ba_array_val(memv);
     return caml_copy_nativeint((intnat) mem->data);
 }
 
@@ -72,7 +72,7 @@
 #ifdef HAVE_SYSCONF
     return Val_long(sysconf(_SC_PAGESIZE));
 #else
-    invalid_argument("Netsys_mem.getpagesize not available");
+    caml_invalid_argument("Netsys_mem.getpagesize not available");
 #endif
 }
 
@@ -83,8 +83,8 @@
 
     start = (void *) Nativeint_val(addrv);
     length = Long_val(lenv);
-    return alloc_bigarray_dims(BIGARRAY_C_LAYOUT | BIGARRAY_UINT8,
-			       1, start, length);
+    return caml_ba_alloc_dims(CAML_BA_C_LAYOUT | CAML_BA_UINT8,
+                              1, start, length);
 }
 
 
@@ -109,15 +109,15 @@
 
     data = mmap(start, length, flags, 
 		MAP_PRIVATE | MAP_ANON, (-1), 0);
-    if (data == (void *) -1) uerror("mmap", Nothing);
+    if (data == (void *) -1) caml_uerror("mmap", Nothing);
 
-    r = alloc_bigarray_dims(BIGARRAY_C_LAYOUT | BIGARRAY_UINT8 | 
-			    BIGARRAY_MAPPED_FILE,
-			    1, data, length);
+    r = caml_ba_alloc_dims(CAML_BA_C_LAYOUT | CAML_BA_UINT8 | 
+                           CAML_BA_MAPPED_FILE,
+                           1, data, length);
 
     return r;
 #else
-    invalid_argument("Netsys_mem.alloc_memory_pages not available");
+    caml_invalid_argument("Netsys_mem.alloc_memory_pages not available");
 #endif
 }
 
@@ -125,7 +125,7 @@
 CAMLprim value netsys_zero_pages(value memv, value offsv, value lenv)
 {
 #if defined(HAVE_MMAP) && defined(HAVE_SYSCONF) && defined(MAP_ANON) && defined (MAP_FIXED)
-    struct caml_bigarray *mem = Bigarray_val(memv);
+    struct caml_ba_array *mem = Caml_ba_array_val(memv);
     long offs = Long_val(offsv);
     long len = Long_val(lenv);
     long pgsize = sysconf(_SC_PAGESIZE);
@@ -137,17 +137,17 @@
 	    data2 = mmap(data, len, PROT_READ|PROT_WRITE, 
 			 MAP_PRIVATE | MAP_ANON | MAP_FIXED,
 			 (-1), 0);
-	    if (data2 == (void *) -1) uerror("mmap", Nothing);
+	    if (data2 == (void *) -1) caml_uerror("mmap", Nothing);
 	    if (((void *) data) != data2)
-		failwith("Netsys_mem.zero_pages assertion failed");
+		caml_failwith("Netsys_mem.zero_pages assertion failed");
 	}
     }
     else
-	invalid_argument("Netsys_mem.zero_pages only for whole pages");
+	caml_invalid_argument("Netsys_mem.zero_pages only for whole pages");
 
     return Val_unit;
 #else
-    invalid_argument("Netsys_mem.zero_pages not available");
+    caml_invalid_argument("Netsys_mem.zero_pages not available");
 #endif
 }
 
@@ -162,14 +162,14 @@
     value r;
 
     e = posix_memalign(&addr, align, size);
-    if (e != 0) unix_error(e, "posix_memalign", Nothing);
+    if (e != 0) caml_unix_error(e, "posix_memalign", Nothing);
 
-    r = alloc_bigarray_dims(BIGARRAY_C_LAYOUT | BIGARRAY_UINT8 | 
-			    BIGARRAY_MANAGED,
-			    1, addr, size);
+    r = caml_ba_alloc_dims(CAML_BA_C_LAYOUT | CAML_BA_UINT8 | 
+                           CAML_BA_MANAGED,
+                           1, addr, size);
     return r;
 #else
-    invalid_argument("Netsys_mem.alloc_aligned_memory not available");
+    caml_invalid_argument("Netsys_mem.alloc_aligned_memory not available");
 #endif
 }
 
@@ -197,7 +197,7 @@
     fd = Int_val(fdv);
     pos0 = Int64_val(posv);
     if (((int64_t) ((off_t) pos0)) != pos0)
-	failwith("Netsys_mem: large files not supported on this OS");
+	caml_failwith("Netsys_mem: large files not supported on this OS");
     pos = pos0;
     addr = (void *) Nativeint_val(addrv);
     if (addr == 0) addr = NULL;
@@ -206,36 +206,36 @@
 
     pagesize = sysconf(_SC_PAGESIZE);
 
-    if (fstat(fd, &st) == -1) uerror("fstat", Nothing);
+    if (fstat(fd, &st) == -1) caml_uerror("fstat", Nothing);
     eofpos = st.st_size;
     
     if (size == -1) {
 	if (eofpos < pos) 
-	    failwith("Netsys_mem: cannot mmap - file position exceeds file size");
+	    caml_failwith("Netsys_mem: cannot mmap - file position exceeds file size");
 	basize0 = eofpos - pos;
 	if (((off_t) ((uintnat) basize0)) != basize0)
-	    failwith("Netsys_mem: cannot mmap - file too large");
+	    caml_failwith("Netsys_mem: cannot mmap - file too large");
 	basize = (uintnat) basize0;
     }
     else {
 	if (size < 0)
-	    invalid_argument("netsys_map_file");
+	    caml_invalid_argument("netsys_map_file");
 	if (eofpos - pos < size) {
 	    if (ftruncate(fd, pos + size) == -1)
-		uerror("ftruncate", Nothing);
+		caml_uerror("ftruncate", Nothing);
 	}
 	basize = size;
     }
     delta = (uintnat) (pos % pagesize);
     eff_addr = mmap(addr, basize + delta, PROT_READ | PROT_WRITE,
 		    shared, fd, pos - delta);
-    if (eff_addr == (void*) MAP_FAILED) uerror("mmap", Nothing);
+    if (eff_addr == (void*) MAP_FAILED) caml_uerror("mmap", Nothing);
     eff_addr = (void *) ((uintnat) eff_addr + delta);
 
-    return alloc_bigarray_dims(BIGARRAY_UINT8 | BIGARRAY_C_LAYOUT | 
-			       BIGARRAY_MAPPED_FILE, 1, eff_addr, basize);
+    return caml_ba_alloc_dims(CAML_BA_UINT8 | CAML_BA_C_LAYOUT | 
+                              CAML_BA_MAPPED_FILE, 1, eff_addr, basize);
 #else
-    invalid_argument("Netsys_mem.memory_map_file not available");
+    caml_invalid_argument("Netsys_mem.memory_map_file not available");
 #endif
 }
 
@@ -254,20 +254,20 @@
 
 CAMLprim value netsys_memory_unmap_file(value memv) 
 {
-    struct caml_bigarray *b = Bigarray_val(memv);
-    if ((b->flags & BIGARRAY_MANAGED_MASK) == BIGARRAY_MAPPED_FILE) {
+    struct caml_ba_array *b = Caml_ba_array_val(memv);
+    if ((b->flags & CAML_BA_MANAGED_MASK) == CAML_BA_MAPPED_FILE) {
 	if (b->proxy == NULL) {
 	    ba_unmap_file(b->data, b->dim[0]);
 	    b->data = NULL;
 	    b->flags = 
-		(b->flags & ~BIGARRAY_MANAGED_MASK) | BIGARRAY_EXTERNAL;
+		(b->flags & ~CAML_BA_MANAGED_MASK) | CAML_BA_EXTERNAL;
 	}
 	else if (b->proxy->refcount == 1) {
 	    ba_unmap_file(b->proxy->data, b->dim[0]);
 	    b->proxy->data = NULL;
 	    b->data = NULL;
 	    b->flags = 
-		(b->flags & ~BIGARRAY_MANAGED_MASK) | BIGARRAY_EXTERNAL;
+		(b->flags & ~CAML_BA_MANAGED_MASK) | CAML_BA_EXTERNAL;
 	}
     }
     return Val_unit;
@@ -278,26 +278,26 @@
 
 CAMLprim value netsys_reshape(value bv)
 {
-    struct caml_bigarray *b;
-    struct caml_bigarray *mem;
+    struct caml_ba_array *b;
+    struct caml_ba_array *mem;
     uintnat size;
     int i,k;
     CAMLparam1(bv);
     CAMLlocal2(memv,dimv);
 
-    b = Bigarray_val(bv);
+    b = Caml_ba_array_val(bv);
 
     /* We dont't have access to caml_ba_update_proxy. The workaround is
        to call caml_ba_reshape, and to fix the returned bigarray descriptor
        afterward.
     */
-    dimv = alloc(b->num_dims,0);
+    dimv = caml_alloc(b->num_dims,0);
     for (k=0; k < b->num_dims; k++) {
 	Store_field(dimv, k, Val_long(b->dim[k]));
     };
     
     memv = caml_ba_reshape(bv, dimv);
-    mem = Bigarray_val(memv);
+    mem = Caml_ba_array_val(memv);
 
     /* Compute the size of the data area: */
     size = caml_ba_element_size[b->flags & CAML_BA_KIND_MASK];
@@ -354,10 +354,14 @@
 
 CAMLprim value netsys_set_color(value objv, value colv)
 {
+#if OCAML_VERSION < 50000
     int col;
     col = Int_val(colv);
     Hd_val(objv) = Whitehd_hd(Hd_val(objv)) | (col << 8);
     return Val_unit;
+#else
+    caml_invalid_argument("Netsys_mem.set_color");
+#endif
 }
 
 /**********************************************************************/
@@ -375,20 +379,20 @@
 #endif
 
     numbytes = Long_val(lenv);
-    data = ((char *) (Bigarray_val(memv)->data)) + Long_val(offv);
+    data = ((char *) (Caml_ba_array_val(memv)->data)) + Long_val(offv);
 #ifdef _WIN32
     if (Descr_kind_val(fdv) == KIND_SOCKET) {
 	SOCKET h = Socket_val(fdv);
-	enter_blocking_section();
+	caml_enter_blocking_section();
 	ret = recv(h, data, numbytes, 0);
 	if (ret == SOCKET_ERROR) err = WSAGetLastError();
-	leave_blocking_section();
+	caml_leave_blocking_section();
 	ret = n;
     } else {
 	HANDLE h = Handle_val(fdv);
-	enter_blocking_section();
+	caml_enter_blocking_section();
 	if (! ReadFile(h, data, numbytes, &n, NULL)) err = GetLastError();
-	leave_blocking_section();
+	caml_leave_blocking_section();
 	ret = n;
     }
     if (err) {
@@ -396,11 +400,11 @@
 	ret = -1;
     }
 #else
-    enter_blocking_section();
+    caml_enter_blocking_section();
     ret = read(Int_val(fdv), data, (int) numbytes);
-    leave_blocking_section();   /* keeps errno intact */
+    caml_leave_blocking_section();   /* keeps errno intact */
 #endif
-    if (ret == -1) uerror("mem_read", Nothing);
+    if (ret == -1) caml_uerror("mem_read", Nothing);
     return Val_long(ret);
 }
 
@@ -416,20 +420,20 @@
 #endif
 
     numbytes = Long_val(lenv);
-    data = ((char *) (Bigarray_val(memv)->data)) + Long_val(offv);
+    data = ((char *) (Caml_ba_array_val(memv)->data)) + Long_val(offv);
 #ifdef _WIN32
     if (Descr_kind_val(fdv) == KIND_SOCKET) {
 	SOCKET h = Socket_val(fdv);
-	enter_blocking_section();
+	caml_enter_blocking_section();
 	ret = send(h, data, numbytes, 0);
 	if (ret == SOCKET_ERROR) err = WSAGetLastError();
-	leave_blocking_section();
+	caml_leave_blocking_section();
 	ret = n;
     } else {
 	HANDLE h = Handle_val(fdv);
-	enter_blocking_section();
+	caml_enter_blocking_section();
 	if (! WriteFile(h, data, numbytes, &n, NULL)) err = GetLastError();
-	leave_blocking_section();
+	caml_leave_blocking_section();
 	ret = n;
     }
     if (err) {
@@ -437,11 +441,11 @@
 	ret = -1;
     }
 #else
-    enter_blocking_section();
+    caml_enter_blocking_section();
     ret = write(Int_val(fdv), data, (int) numbytes);
-    leave_blocking_section();
+    caml_leave_blocking_section();
 #endif
-    if (ret == -1) uerror("mem_write", Nothing);
+    if (ret == -1) caml_uerror("mem_write", Nothing);
     return Val_long(ret);
 }
 
@@ -466,8 +470,8 @@
 #endif
 
     numbytes = Long_val(lenv);
-    data = ((char *) (Bigarray_val(memv)->data)) + Long_val(offv);
-    flags = convert_flag_list(flagsv, msg_flag_table);
+    data = ((char *) (Caml_ba_array_val(memv)->data)) + Long_val(offv);
+    flags = caml_convert_flag_list(flagsv, msg_flag_table);
 
 #ifdef _WIN32
     s = Socket_val(fdv);
@@ -475,18 +479,18 @@
     s = Int_val(fdv);
 #endif
 
-    enter_blocking_section();
+    caml_enter_blocking_section();
     ret = recv(s, data, (int) numbytes, flags);
 
 #ifdef _WIN32
     if (ret == -1) err = WSAGetLastError();
-    leave_blocking_section();
+    caml_leave_blocking_section();
     if (ret == -1) win32_maperr(err);
 #else
-    leave_blocking_section();
+    caml_leave_blocking_section();
 #endif
 
-    if (ret == -1) uerror("mem_recv", Nothing);
+    if (ret == -1) caml_uerror("mem_recv", Nothing);
     return Val_long(ret);
 }
 
@@ -506,8 +510,8 @@
 #endif
 
     numbytes = Long_val(lenv);
-    data = ((char *) (Bigarray_val(memv)->data)) + Long_val(offv);
-    flags = convert_flag_list(flagsv, msg_flag_table);
+    data = ((char *) (Caml_ba_array_val(memv)->data)) + Long_val(offv);
+    flags = caml_convert_flag_list(flagsv, msg_flag_table);
 
 #ifdef _WIN32
     s = Socket_val(fdv);
@@ -515,18 +519,18 @@
     s = Int_val(fdv);
 #endif
 
-    enter_blocking_section();
+    caml_enter_blocking_section();
     ret = send(s, data, (int) numbytes, flags);
 
 #ifdef _WIN32
     if (ret == -1) err = WSAGetLastError();
-    leave_blocking_section();
+    caml_leave_blocking_section();
     if (ret == -1) win32_maperr(err);
 #else
-    leave_blocking_section();
+    caml_leave_blocking_section();
 #endif
 
-    if (ret == -1) uerror("mem_send", Nothing);
+    if (ret == -1) caml_uerror("mem_send", Nothing);
     return Val_long(ret);
 }
 
@@ -537,44 +541,48 @@
 
 CAMLprim value netsys_as_value(value memv, value offv) 
 {
-    struct caml_bigarray *b = Bigarray_val(memv);
+#if OCAML_VERSION < 50000
+    struct caml_ba_array *b = Caml_ba_array_val(memv);
     return (value) (b->data + Long_val(offv));
+#else
+    caml_invalid_argument("Netsys_mem.as_value");
+#endif
 }
 
 CAMLprim value netsys_value_area_add(value memv) 
 {
-#ifdef FANCY_PAGE_TABLES
-    struct caml_bigarray *b = Bigarray_val(memv);
+#if defined(FANCY_PAGE_TABLES) && OCAML_VERSION < 50000
+    struct caml_ba_array *b = Caml_ba_array_val(memv);
     int code;
     code = caml_page_table_add(In_static_data,
 			       b->data,
 			       b->data + b->dim[0]);
     if (code != 0) 
-	failwith("Netsys_mem.value_area: error");
+	caml_failwith("Netsys_mem.value_area: error");
     return Val_unit;
 #else
-    invalid_argument("Netsys_mem.value_area");
+    caml_invalid_argument("Netsys_mem.value_area");
 #endif
 }
 
 CAMLprim value netsys_value_area_remove(value memv) 
 {
-#ifdef FANCY_PAGE_TABLES
-    struct caml_bigarray *b = Bigarray_val(memv);
+#if defined(FANCY_PAGE_TABLES) && OCAML_VERSION < 50000
+    struct caml_ba_array *b = Caml_ba_array_val(memv);
     caml_page_table_remove(In_static_data,
                            b->data,
                            b->data + b->dim[0]);
     /* Silently ignore errors... */
     return Val_unit;
 #else
-    invalid_argument("Netsys_mem.value_area");
+    caml_invalid_argument("Netsys_mem.value_area");
 #endif
 }
 
 CAMLprim value netsys_init_header(value memv, value offv, value tagv,
 				  value sizev)
 {
-    struct caml_bigarray *b = Bigarray_val(memv);
+    struct caml_ba_array *b = Caml_ba_array_val(memv);
     intnat off = Long_val(offv);
     intnat size = Long_val(sizev);
     int tag = Int_val(tagv);
@@ -582,10 +590,10 @@
 
 #ifdef ARCH_SIXTYFOUR
     if (off % 8 != 0)
-	invalid_argument("Netsys_mem.init_header");
+	caml_invalid_argument("Netsys_mem.init_header");
 #else
     if (off % 4 != 0)
-	invalid_argument("Netsys_mem.init_header");
+	caml_invalid_argument("Netsys_mem.init_header");
 #endif
 
     m = (value *) (((char *) b->data) + off);
@@ -619,7 +627,7 @@
 
 CAMLprim value netsys_init_string(value memv, value offv, value lenv) 
 {
-    struct caml_bigarray *b = Bigarray_val(memv);
+    struct caml_ba_array *b = Caml_ba_array_val(memv);
     intnat off = Long_val(offv);
     intnat len = Long_val(lenv);
     value *m;
@@ -629,10 +637,10 @@
 
 #ifdef ARCH_SIXTYFOUR
     if (off % 8 != 0)
-	invalid_argument("Netsys_mem.init_string");
+	caml_invalid_argument("Netsys_mem.init_string");
 #else
     if (off % 4 != 0)
-	invalid_argument("Netsys_mem.init_string");
+	caml_invalid_argument("Netsys_mem.init_string");
 #endif
 
     m = (value *) (((char *) b->data) + off);
@@ -650,6 +658,8 @@
 }
 
 
+#if OCAML_VERSION < 50000
+
 struct named_custom_ops {
     char *name;
     void *ops;
@@ -999,14 +1009,14 @@
 		    size_t size = 1;
 		    size_t size_aligned;
 		    size_t size_words;
-		    b_work = Bigarray_val(work);
-		    b_copy = Bigarray_val(copy);
+		    b_work = Caml_ba_array_val(work);
+		    b_copy = Caml_ba_array_val(copy);
 		    for (i = 0; i < b_work->num_dims; i++) {
 			size = size * b_work->dim[i];
 		    };
 		    size = 
 			size * 
-			caml_ba_element_size[b_work->flags & BIGARRAY_KIND_MASK];
+			caml_ba_element_size[b_work->flags & CAML_BA_KIND_MASK];
 
 		    size_aligned = size;
 		    if (size%sizeof(void *) != 0)
@@ -1035,7 +1045,7 @@
 			dest_cur += size_aligned;
 		    } else if (!simulation) {
 			data_header = NULL;
-			data_copy = stat_alloc(size_aligned);
+			data_copy = caml_stat_alloc(size_aligned);
 		    };
 
 		    if (!simulation) {
@@ -1197,8 +1207,8 @@
     if (netsys_queue_size(stat_queue) > 256)
 	netsys_queue_free(stat_queue);
 }
+#endif
 
-
 value netsys_init_value(value memv, 
 			value offv, 
 			value orig,  
@@ -1208,6 +1218,7 @@
                         value cc
 			)
 {
+#if OCAML_VERSION < 50000
     int code;
     value r;
     intnat start_offset, bytelen;
@@ -1254,16 +1265,16 @@
 	old_ops = ops;
 	pair = Field(target_custom_ops,0);
 	ops = (struct named_custom_ops*) 
-	          stat_alloc(sizeof(struct named_custom_ops));
-	ops->name = stat_alloc(caml_string_length(Field(pair,0))+1);
+	          caml_stat_alloc(sizeof(struct named_custom_ops));
+	ops->name = caml_stat_alloc(caml_string_length(Field(pair,0))+1);
 	strcmp(ops->name, String_val(Field(pair,0)));
 	ops->ops = (void *) Nativeint_val(Field(pair,1));
 	ops->next = old_ops;
 	target_custom_ops = Field(target_custom_ops,1);
     };
 
-    mem_data = ((char *) Bigarray_val(memv)->data) + off;
-    mem_end = mem_data + Bigarray_val(memv)->dim[0];
+    mem_data = ((char *) Caml_ba_array_val(memv)->data) + off;
+    mem_end = mem_data + Caml_ba_array_val(memv)->dim[0];
 
     /* note: the color of the new values does not matter because bigarrays
        are ignored by the GC. So we pass 0 (white).
@@ -1287,8 +1298,8 @@
 
     while (ops != NULL) {
 	next_ops = ops->next;
-	stat_free(ops->name);
-	stat_free(ops);
+	caml_stat_free(ops->name);
+	caml_stat_free(ops);
 	ops = next_ops;
     };
     
@@ -1304,17 +1315,20 @@
 
     switch(code) {
     case (-1):
-	unix_error(errno, "netsys_init_value", Nothing);
+	caml_unix_error(errno, "netsys_init_value", Nothing);
     case (-2):
 #ifdef DEBUG
         fprintf(stderr, "Lib err\n");
 #endif
-	failwith("Netsys_mem.init_value: Library error");
+	caml_failwith("Netsys_mem.init_value: Library error");
     case (-4):
 	caml_raise_constant(*caml_named_value("Netsys_mem.Out_of_space"));
     default:
-	failwith("Netsys_mem.init_value: Unknown error");
+	caml_failwith("Netsys_mem.init_value: Unknown error");
     }
+#else
+    caml_invalid_argument("Netsys_mem.init_value");
+#endif
 }
 
 
@@ -1344,6 +1358,7 @@
 
 value netsys_copy_value(value flags, value orig)
 {
+#if OCAML_VERSION < 50000
     int code;
     int cflags;
     intnat start_offset, bytelen;
@@ -1389,8 +1404,8 @@
     */
     bigarray_ops.name = BIGARRAY_MARSHAL_ID;
     bigarray_ops.ops = 
-	Custom_ops_val(alloc_bigarray_dims(CAML_BA_UINT8 | BIGARRAY_C_LAYOUT, 
-					   1, NULL, 1));
+	Custom_ops_val(caml_ba_alloc_dims(CAML_BA_UINT8 | CAML_BA_C_LAYOUT, 
+                                          1, NULL, 1));
     bigarray_ops.next = &int32_ops;
 
     int32_ops.name = "_i";
@@ -1490,38 +1505,45 @@
 
     switch(code) {
     case (-1):
-	unix_error(errno, "netsys_copy_value", Nothing);
+	caml_unix_error(errno, "netsys_copy_value", Nothing);
     case (-2):
-	failwith("Netsys_mem.copy_value: Library error");
+	caml_failwith("Netsys_mem.copy_value: Library error");
     case (-4):
 	caml_raise_constant(*caml_named_value("Netsys_mem.Out_of_space"));
     default:
-	failwith("Netsys_mem.copy_value: Unknown error");
+	caml_failwith("Netsys_mem.copy_value: Unknown error");
     }
+#else
+    caml_invalid_argument("Netsys_mem.copy_value");
+#endif
 }
 
 
 value netsys_get_custom_ops (value v) 
 {
+#if OCAML_VERSION < 50000
     struct custom_operations *custom_ops;
     CAMLparam1(v);
     CAMLlocal1(r);
 
     if (Is_block(v) && Tag_val(v) == Custom_tag) {
 	custom_ops = Custom_ops_val(v);
-	r = alloc_small(2,0);
+	r = caml_alloc_small(2,0);
 	Field(r,0) = caml_copy_string(custom_ops->identifier);
 	Field(r,1) = caml_copy_nativeint((intnat) custom_ops);
     }
     else 
-	invalid_argument("Netsys_mem.get_custom_ops");
+	caml_invalid_argument("Netsys_mem.get_custom_ops");
 
     CAMLreturn(r);
+#else
+    caml_invalid_argument("Netsys_mem.get_custom_ops");
+#endif
 }
 
 
 value netsys_is_bigarray(value v) {
-    struct custom_operations *custom_ops;
+    const struct custom_operations *custom_ops;
     CAMLparam1(v);
     CAMLlocal1(r);
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_multicast.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_multicast.c
--- src/netsys/netsys_c_multicast.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_multicast.c	2026-05-29 06:31:44
@@ -43,7 +43,7 @@
         return PF_INET6;
 #endif
     default:
-	invalid_argument("Not an Internet socket");
+	caml_invalid_argument("Not an Internet socket");
     }
 
     return 0;
@@ -77,7 +77,7 @@
 #endif
 #endif
     default:
-	invalid_argument("Netsys.mcast_set_loop");
+	caml_invalid_argument("Netsys.mcast_set_loop");
     };
 
     if (r == -1)
@@ -93,7 +93,7 @@
 
 #ifdef _WIN32
     if (Descr_kind_val(fd) != KIND_SOCKET)
-	invalid_argument("Netsys.mcast_set_ttl");
+	caml_invalid_argument("Netsys.mcast_set_ttl");
     fd_sock = Socket_val(fd);
 #else
     fd_sock = Int_val(fd);
@@ -123,7 +123,7 @@
 #endif
 #endif
     default:
-	invalid_argument("Netsys.mcast_set_ttl");
+	caml_invalid_argument("Netsys.mcast_set_ttl");
     };
 
     if (r == -1)
@@ -141,7 +141,7 @@
 
 #ifdef _WIN32
     if (Descr_kind_val(fd) != KIND_SOCKET)
-	invalid_argument("Netsys.mcast_add_membership");
+	caml_invalid_argument("Netsys.mcast_add_membership");
     fd_sock = Socket_val(fd);
 #else
     fd_sock = Int_val(fd);
@@ -154,8 +154,8 @@
 #ifdef IP_ADD_MEMBERSHIP
     case PF_INET: {
         struct ip_mreq mreq;
-        if (string_length(group_addr) != 4 || string_length(if_addr) != 4 )
-            invalid_argument("Netsys.mcast_add_membership: Not an IPV4 address");
+        if (caml_string_length(group_addr) != 4 || caml_string_length(if_addr) != 4 )
+            caml_invalid_argument("Netsys.mcast_add_membership: Not an IPV4 address");
         memcpy(&mreq.imr_multiaddr,
                &GET_INET_ADDR(group_addr),
                4);
@@ -173,8 +173,8 @@
 #ifdef IPV6_ADD_MEMBERSHIP
     case PF_INET6: {
         struct ipv6_mreq mreq;
-        if (string_length(group_addr) != 16 || string_length(if_addr) != 16 )
-            invalid_argument("Netsys.mcast_add_membership: Not an IPV6 address");
+        if (caml_string_length(group_addr) != 16 || caml_string_length(if_addr) != 16 )
+            caml_invalid_argument("Netsys.mcast_add_membership: Not an IPV6 address");
         memcpy(&mreq.ipv6mr_multiaddr,
                &GET_INET6_ADDR(group_addr),
                16);
@@ -193,7 +193,7 @@
 #endif
 #endif
     default:
-	invalid_argument("Netsys.mcast_add_membership");
+	caml_invalid_argument("Netsys.mcast_add_membership");
     };
     if (r == -1)
         uerror("setsockopt",Nothing);
@@ -210,7 +210,7 @@
 
 #ifdef _WIN32
     if (Descr_kind_val(fd) != KIND_SOCKET)
-	invalid_argument("Netsys.mcast_drop_membership");
+	caml_invalid_argument("Netsys.mcast_drop_membership");
     fd_sock = Socket_val(fd);
 #else
     fd_sock = Int_val(fd);
@@ -223,8 +223,8 @@
 #ifdef IP_DROP_MEMBERSHIP
     case PF_INET: {
         struct ip_mreq mreq;
-        if (string_length(group_addr) != 4 || string_length(if_addr) != 4 )
-            invalid_argument("Netsys.mcast_drop_membership: Not an IPV4 address");
+        if (caml_string_length(group_addr) != 4 || caml_string_length(if_addr) != 4 )
+            caml_invalid_argument("Netsys.mcast_drop_membership: Not an IPV4 address");
         memcpy(&mreq.imr_multiaddr,
                &GET_INET_ADDR(group_addr),
                4);
@@ -242,8 +242,8 @@
 #ifdef IPV6_DROP_MEMBERSHIP
     case PF_INET6: {
         struct ipv6_mreq mreq;
-        if (string_length(group_addr) != 16 || string_length(if_addr) != 16 )
-            invalid_argument("Netsys.mcast_drop_membership: Not an IPV6 address");
+        if (caml_string_length(group_addr) != 16 || caml_string_length(if_addr) != 16 )
+            caml_invalid_argument("Netsys.mcast_drop_membership: Not an IPV6 address");
         memcpy(&mreq.ipv6mr_multiaddr,
                &GET_INET6_ADDR(group_addr),
                16);
@@ -262,7 +262,7 @@
 #endif
 #endif
     default:
-	invalid_argument("Netsys.mcast_drop_membership");
+	caml_invalid_argument("Netsys.mcast_drop_membership");
     };
 
     if (r == -1)
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_outofheap.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_outofheap.c
--- src/netsys/netsys_c_outofheap.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_outofheap.c	2026-05-29 06:31:44
@@ -9,7 +9,7 @@
 
 #include "netsys_c.h"
 
-#ifdef HAVE_NEW_MODIFY
+#if defined(HAVE_NEW_MODIFY) && OCAML_VERSION < 50000
 /* implies FANCY_PAGE_TABLES */
 
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_poll.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_poll.c
--- src/netsys/netsys_c_poll.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_poll.c	2026-05-29 06:31:44
@@ -75,7 +75,7 @@
     };
     return s;
 #else
-    invalid_argument("netsys_mk_poll_mem");
+    caml_invalid_argument("netsys_mk_poll_mem");
 #endif
 }
 
@@ -89,7 +89,7 @@
     (*(Poll_mem_val(s)))[Int_val(k)] = p;
     return Val_unit;
 #else
-    invalid_argument("netsys_set_poll_mem");
+    caml_invalid_argument("netsys_set_poll_mem");
 #endif
 
 }
@@ -106,7 +106,7 @@
     Store_field(triple, 2, Val_int(p.revents));
     return triple;
 #else
-    invalid_argument("netsys_get_poll_mem");
+    caml_invalid_argument("netsys_get_poll_mem");
 #endif
 }
 
@@ -120,7 +120,7 @@
     memmove(p2 + Int_val(k2), p1 + Int_val(k1), l*sizeof(struct pollfd));
     return Val_unit;
 #else
-    invalid_argument("netsys_blit_poll_mem");
+    caml_invalid_argument("netsys_blit_poll_mem");
 #endif
 };
 
@@ -148,15 +148,15 @@
     n = Int_val(nv);
     tmo = Long_val(tv);
     
-    enter_blocking_section();
+    caml_enter_blocking_section();
     r = poll(p, n, tmo);
-    leave_blocking_section();
+    caml_leave_blocking_section();
 
-    if (r == -1) uerror("poll", Nothing);
+    if (r == -1) caml_uerror("poll", Nothing);
     
     return Val_int(r);
 #else
-     invalid_argument("netsys_poll");
+     caml_invalid_argument("netsys_poll");
 #endif
 }
 
@@ -224,12 +224,12 @@
 
 #ifdef USABLE_EPOLL
     fd = epoll_create(128);
-    if (fd == -1) uerror("epoll_create", Nothing);
+    if (fd == -1) caml_uerror("epoll_create", Nothing);
     code = fcntl(fd, F_SETFD, FD_CLOEXEC);
     if (code == -1) {
 	e = errno;
 	close(fd);
-	unix_error(e, "fcntl", Nothing);
+	caml_unix_error(e, "fcntl", Nothing);
     };
     r = alloc_poll_aggreg();
     pa = *(Poll_aggreg_val(r));
@@ -243,14 +243,14 @@
 	if (cancel_fd == -1) {
 	    e = errno;
 	    close(fd);
-	    unix_error(e, "eventfd", Nothing);
+	    caml_unix_error(e, "eventfd", Nothing);
 	};
 	code = fcntl(cancel_fd, F_SETFD, FD_CLOEXEC);
 	if (code == -1) {
 	    e = errno;
 	    close(fd);
 	    close(cancel_fd);
-	    unix_error(e, "fcntl", Nothing);
+	    caml_unix_error(e, "fcntl", Nothing);
 	};
 	ee.events = EPOLLIN;  /* not oneshot! */
 	ee.data.u64 = 1;  /* reserved value */
@@ -259,14 +259,14 @@
 	    e = errno;
 	    close(fd);
 	    close(cancel_fd);
-	    unix_error(e, "epoll_ctl (ADD)", Nothing);
+	    caml_unix_error(e, "epoll_ctl (ADD)", Nothing);
 	};
 	pa->cancel_fd = cancel_fd;
     };
 #endif
     return r;
 #else
-    invalid_argument("Netsys_posix.create_event_aggregator not available");
+    caml_invalid_argument("Netsys_posix.create_event_aggregator not available");
 #endif
 }
 
@@ -279,14 +279,14 @@
 
     pa = *(Poll_aggreg_val(pav));
     code = close(pa->fd);
-    if (code == -1) uerror("close", Nothing);
+    if (code == -1) caml_uerror("close", Nothing);
     if (pa->cancel_fd >= 0) {
 	code = close(pa->cancel_fd);
-	if (code == -1) uerror("close", Nothing);
+	if (code == -1) caml_uerror("close", Nothing);
     };
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.destroy_event_aggregator not available");
+    caml_invalid_argument("Netsys_posix.destroy_event_aggregator not available");
 #endif
 }
 
@@ -299,7 +299,7 @@
     pa = *(Poll_aggreg_val(pav));
     return Val_int(pa->fd);
 #else
-    invalid_argument("Netsys_posix.event_aggregator_fd not available");
+    caml_invalid_argument("Netsys_posix.event_aggregator_fd not available");
 #endif
 }
 
@@ -348,12 +348,12 @@
 	translate_to_epoll_events(Int_val(Field(pushv, 2))) | EPOLLONESHOT;
     ee.data.u64 = Long_val(Field(pushv, 0)) << 1;
     code = epoll_ctl(pa->fd, EPOLL_CTL_ADD, fd, &ee);
-    if (code == -1) uerror("epoll_ctl (ADD)", Nothing);
+    if (code == -1) caml_uerror("epoll_ctl (ADD)", Nothing);
 #endif
 
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.add_event_source not available");
+    caml_invalid_argument("Netsys_posix.add_event_source not available");
 #endif
 }
 
@@ -373,12 +373,12 @@
 
 #ifdef USABLE_EPOLL
     code = epoll_ctl(pa->fd, EPOLL_CTL_DEL, fd, &ee);
-    if (code == -1) uerror("epoll_ctl (DEL)", Nothing);
+    if (code == -1) caml_uerror("epoll_ctl (DEL)", Nothing);
 #endif
 
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.del_event_source not available");
+    caml_invalid_argument("Netsys_posix.del_event_source not available");
 #endif
 }
 
@@ -394,11 +394,11 @@
         int n;
 	buf = 1;
 	n = write(pa->cancel_fd, (char *) &buf, 8);
-        if (n == -1) uerror("write", Nothing);
+        if (n == -1) caml_uerror("write", Nothing);
     };
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.interrupt_event_aggregator not available");
+    caml_invalid_argument("Netsys_posix.interrupt_event_aggregator not available");
 #endif
 }
 
@@ -427,12 +427,12 @@
 	    EPOLLONESHOT;
 	ee.data.u64 = Long_val(Field(v_pushlist_hd, 0)) << 1;
 	code = epoll_ctl(pa->fd, EPOLL_CTL_MOD, fd, &ee);
-	if (code == -1) uerror("epoll_ctl (MOD)", Nothing);
+	if (code == -1) caml_uerror("epoll_ctl (MOD)", Nothing);
 #endif
     };
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.push_event_sources not available");
+    caml_invalid_argument("Netsys_posix.push_event_sources not available");
 #endif
 }
 
@@ -459,7 +459,7 @@
     code = epoll_wait(pa->fd, ee, EPOLL_NUM, tmo);
     e = errno;
     caml_leave_blocking_section();
-    if (code == -1) unix_error(e, "epoll_wait", Nothing);
+    if (code == -1) caml_unix_error(e, "epoll_wait", Nothing);
 
     r = Val_int(0);
     for (k=0; k<code; k++) {
@@ -467,7 +467,7 @@
 	    uint64_t buf;
             int n;
 	    n = read(pa->cancel_fd, (char *) &buf, 8);
-            if (n == -1) unix_error(errno, "read", Nothing);
+            if (n == -1) caml_unix_error(errno, "read", Nothing);
 	}
 	else {
 	    r_item = caml_alloc(3,0);
@@ -486,6 +486,6 @@
 
     CAMLreturn(r);
 #else
-    invalid_argument("Netsys_posix.pull_event_sources not available");
+    caml_invalid_argument("Netsys_posix.pull_event_sources not available");
 #endif
 }
